﻿using System;
using System.Collections.ObjectModel;
using System.IO;
using BeeCoders.Tools.Wpf.Infrastructure;

namespace BeeCoders.Tools.Wpf.FileExplorer
{
	public class DirectoryViewModel : ItemViewModel
	{

		public bool ShowFiles { get; set; }

		private bool isExpanded;
		public bool IsExpanded
		{
			get { return isExpanded; }
			set
			{
				if (value != isExpanded)
				{
					isExpanded = value;
					RaisePropertyChanged("IsExpanded");
					RaisePropertyChanged("ImageName");

					if (FileExplorerViewModel.Instance.ShowDirectories)
					{
						foreach (var child in Childs)
						{
							if (child is DirectoryViewModel)
							{
								((DirectoryViewModel)child).LoadChilds(FileExplorerViewModel.Instance.ShowFiles);
							}
						}
					}
					else
					{
						Childs.Clear();
					}

				}
			}
		}

		public new object ImageName
		{
			get
			{
				if (IsExpanded) return "../Images/Folder 198.ico"; 
				
				return "../Images/Folder 199.ico";
			}
		}


		public ObservableCollectionEx<ViewModelBase> Childs { get; set; }

		public DirectoryViewModel(string fullPath, string name,bool showFiles)
		{
			FullPath = fullPath;
			Name = name;
			HasCheckbox = true;
			ShowFiles = showFiles;

			Childs = new ObservableCollectionEx<ViewModelBase>();
		}

		public void UpdateView()
		{
			foreach (ViewModelBase child in Childs)
			{
				child.RaisePropertyChanged("HasCheckbox");
				child.RaisePropertyChanged("ShowIcons");

				if (child is DirectoryViewModel)
					((DirectoryViewModel)child).UpdateView();
			}

		}

		public void LoadChilds(bool showFiles)
		{
			try
			{
				foreach (string directory in Directory.GetDirectories(FullPath))
				{
					var directoryInfo = new DirectoryInfo(directory);
					Childs.Add(new DirectoryViewModel(directory, directoryInfo.Name,showFiles));
				}

				if (showFiles)
				{
					foreach (string file in Directory.GetFiles(FullPath))
					{
						var fileInfo = new FileInfo(file);
						Childs.Add(new FileViewModel(file, fileInfo.Name));
					}
				}
			}
			catch (UnauthorizedAccessException)
			{
				
			}
			
		}
	}

}
