﻿using System.Collections.ObjectModel;
using System.IO;
using BeeCoders.Tools.Wpf.Infrastructure;

namespace BeeCoders.Tools.Wpf.FileExplorer
{
	public class FtpViewModel : ItemViewModel
	{

		public bool ShowDirectories { get; set; }
		public bool ShowFiles { get; set; }

		private bool isExpanded;
		public bool IsExpanded
		{
			get { return isExpanded; }
			set
			{
				if (value != isExpanded)
				{
					isExpanded = value;
					RaisePropertyChanged("IsExpanded");

					if (FileExplorerViewModel.Instance.ShowDirectories)
					{
						foreach (var child in Childs)
						{
							if (child is DirectoryViewModel)
							{
								((DirectoryViewModel)child).LoadChilds(FileExplorerViewModel.Instance.ShowFiles);
							}
						}
					}
					else
					{
						Childs.Clear();
					}

				}
			}
		}

		public new object ImageName
		{
			get
			{

				return "../Images/HD 336.ico";
			}
		}

		public ObservableCollectionEx<ViewModelBase> Childs { get; set; }

		public FtpViewModel(string name, string fullPath, bool showDirectories, bool showFiles)
		{
			Name = name;
			FullPath = fullPath;

			HasCheckbox = true;
			ShowDirectories = showDirectories;
			ShowFiles = showFiles;

			Childs = new ObservableCollectionEx<ViewModelBase>();

			if (showDirectories) LoadChilds(showFiles);
		}

		public void UpdateView()
		{
			foreach (ViewModelBase child in Childs)
			{
				child.RaisePropertyChanged("HasCheckbox");
				child.RaisePropertyChanged("ShowIcons");

				if (child is DirectoryViewModel)
					((DirectoryViewModel)child).UpdateView();
			}

		}

		public void LoadChilds(bool showFiles)
		{
			try
			{
				foreach (string directory in Directory.GetDirectories(Name))
				{
					var directoryInfo = new DirectoryInfo(directory);
					Childs.Add(new DirectoryViewModel(directory, directoryInfo.Name,showFiles));
				}

				if (showFiles)
				{
					foreach (string file in Directory.GetFiles(Name))
					{
						var fileInfo = new FileInfo(file);
						Childs.Add(new FileViewModel(file, fileInfo.Name));
					}
				}
			}
			catch (IOException)
			{
				
				
			}
			
		}
	}

}
